package net.mcreator.enderitestuff.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.EditBox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.Minecraft;

import net.mcreator.enderitestuff.world.inventory.KeyIDSetupMenu;
import net.mcreator.enderitestuff.procedures.BarrelCardIdInfoGUIProcedure;
import net.mcreator.enderitestuff.network.KeyIDSetupButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class KeyIDSetupScreen extends AbstractContainerScreen<KeyIDSetupMenu> {
	private final static HashMap<String, Object> guistate = KeyIDSetupMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	EditBox key_id;
	Button button_set;

	public KeyIDSetupScreen(KeyIDSetupMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 174;
		this.imageHeight = 50;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("enderite__stuff:textures/screens/key_id_setup.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		key_id.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(RenderType::guiTextured, texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		if (key_id.isFocused())
			return key_id.keyPressed(key, b, c);
		return super.keyPressed(key, b, c);
	}

	@Override
	public void resize(Minecraft minecraft, int width, int height) {
		String key_idValue = key_id.getValue();
		super.resize(minecraft, width, height);
		key_id.setValue(key_idValue);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.enderite__stuff.key_id_setup.label_input_key_id_here"), 39, 3, -12829636, false);
		guiGraphics.drawString(this.font,

				BarrelCardIdInfoGUIProcedure.execute(entity), 7, 34, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		key_id = new EditBox(this.font, this.leftPos + 7, this.topPos + 14, 118, 18, Component.translatable("gui.enderite__stuff.key_id_setup.key_id")) {
			@Override
			public void insertText(String text) {
				super.insertText(text);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.enderite__stuff.key_id_setup.key_id").getString());
				else
					setSuggestion(null);
			}

			@Override
			public void moveCursorTo(int pos, boolean flag) {
				super.moveCursorTo(pos, flag);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.enderite__stuff.key_id_setup.key_id").getString());
				else
					setSuggestion(null);
			}
		};
		key_id.setMaxLength(32767);
		key_id.setSuggestion(Component.translatable("gui.enderite__stuff.key_id_setup.key_id").getString());
		guistate.put("text:key_id", key_id);
		this.addWidget(this.key_id);
		button_set = Button.builder(Component.translatable("gui.enderite__stuff.key_id_setup.button_set"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new KeyIDSetupButtonMessage(0, x, y, z));
				KeyIDSetupButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 128, this.topPos + 13, 40, 20).build();
		guistate.put("button:button_set", button_set);
		this.addRenderableWidget(button_set);
	}
}
