package net.mcreator.enderitestuff.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.EditBox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.Minecraft;

import net.mcreator.enderitestuff.world.inventory.LootBarrelGUIMenu;
import net.mcreator.enderitestuff.procedures.CurrentIDProviderProcedure;
import net.mcreator.enderitestuff.network.LootBarrelGUIButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class LootBarrelGUIScreen extends AbstractContainerScreen<LootBarrelGUIMenu> {
	private final static HashMap<String, Object> guistate = LootBarrelGUIMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	EditBox barrel_code;
	Button button_set;

	public LootBarrelGUIScreen(LootBarrelGUIMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 166;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("enderite__stuff:textures/screens/keycard_barrel_gui.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		barrel_code.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(RenderType::guiTextured, texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		if (barrel_code.isFocused())
			return barrel_code.keyPressed(key, b, c);
		return super.keyPressed(key, b, c);
	}

	@Override
	public void resize(Minecraft minecraft, int width, int height) {
		String barrel_codeValue = barrel_code.getValue();
		super.resize(minecraft, width, height);
		barrel_code.setValue(barrel_codeValue);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.enderite__stuff.keycard_barrel_gui.label_locked_barrel"), 8, 5, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.enderite__stuff.keycard_barrel_gui.label_barrel_code"), 7, -29, -1, false);
		guiGraphics.drawString(this.font,

				CurrentIDProviderProcedure.execute(world, x, y, z), 59, -29, -1, false);
	}

	@Override
	public void init() {
		super.init();
		barrel_code = new EditBox(this.font, this.leftPos + 8, this.topPos + -18, 118, 18, Component.translatable("gui.enderite__stuff.keycard_barrel_gui.barrel_code")) {
			@Override
			public void insertText(String text) {
				super.insertText(text);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.enderite__stuff.keycard_barrel_gui.barrel_code").getString());
				else
					setSuggestion(null);
			}

			@Override
			public void moveCursorTo(int pos, boolean flag) {
				super.moveCursorTo(pos, flag);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.enderite__stuff.keycard_barrel_gui.barrel_code").getString());
				else
					setSuggestion(null);
			}
		};
		barrel_code.setMaxLength(32767);
		barrel_code.setSuggestion(Component.translatable("gui.enderite__stuff.keycard_barrel_gui.barrel_code").getString());
		guistate.put("text:barrel_code", barrel_code);
		this.addWidget(this.barrel_code);
		button_set = Button.builder(Component.translatable("gui.enderite__stuff.keycard_barrel_gui.button_set"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new LootBarrelGUIButtonMessage(0, x, y, z));
				LootBarrelGUIButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 127, this.topPos + -19, 40, 20).build();
		guistate.put("button:button_set", button_set);
		this.addRenderableWidget(button_set);
	}
}
