
package net.mcreator.enderitestuff.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.state.LivingEntityRenderState;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.model.geom.ModelPart;

import net.mcreator.enderitestuff.entity.SpikeEntity;
import net.mcreator.enderitestuff.client.model.animations.spikesAnimation;
import net.mcreator.enderitestuff.client.model.Modelspikes;

public class SpikeRenderer extends MobRenderer<SpikeEntity, LivingEntityRenderState, Modelspikes> {
	private SpikeEntity entity = null;

	public SpikeRenderer(EntityRendererProvider.Context context) {
		super(context, new AnimatedModel(context.bakeLayer(Modelspikes.LAYER_LOCATION)), 1f);
	}

	@Override
	public LivingEntityRenderState createRenderState() {
		return new LivingEntityRenderState();
	}

	@Override
	public void extractRenderState(SpikeEntity entity, LivingEntityRenderState state, float partialTicks) {
		super.extractRenderState(entity, state, partialTicks);
		this.entity = entity;
		if (this.model instanceof AnimatedModel) {
			((AnimatedModel) this.model).setEntity(entity);
		}
	}

	@Override
	public ResourceLocation getTextureLocation(LivingEntityRenderState state) {
		return ResourceLocation.parse("enderite__stuff:textures/entities/spikestexture.png");
	}

	private static final class AnimatedModel extends Modelspikes {
		private SpikeEntity entity = null;

		public AnimatedModel(ModelPart root) {
			super(root);
		}

		public void setEntity(SpikeEntity entity) {
			this.entity = entity;
		}

		@Override
		public void setupAnim(LivingEntityRenderState state) {
			this.root().getAllParts().forEach(ModelPart::resetPose);
			this.animate(entity.animationState0, spikesAnimation.spikesupdown, state.ageInTicks, 1f);
			super.setupAnim(state);
		}
	}
}
