
package net.mcreator.enderitestuff.fluid;

import net.neoforged.neoforge.fluids.BaseFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;

import net.mcreator.enderitestuff.init.EnderiteStuffModItems;
import net.mcreator.enderitestuff.init.EnderiteStuffModFluids;
import net.mcreator.enderitestuff.init.EnderiteStuffModFluidTypes;
import net.mcreator.enderitestuff.init.EnderiteStuffModBlocks;

public abstract class DarkMatterFluid extends BaseFlowingFluid {
	public static final BaseFlowingFluid.Properties PROPERTIES = new BaseFlowingFluid.Properties(() -> EnderiteStuffModFluidTypes.DARK_MATTER_TYPE.get(), () -> EnderiteStuffModFluids.DARK_MATTER.get(),
			() -> EnderiteStuffModFluids.FLOWING_DARK_MATTER.get()).explosionResistance(100f).tickRate(100).slopeFindDistance(1).bucket(() -> EnderiteStuffModItems.DARK_MATTER_BUCKET.get())
			.block(() -> (LiquidBlock) EnderiteStuffModBlocks.DARK_MATTER.get());

	private DarkMatterFluid() {
		super(PROPERTIES);
	}

	public static class Source extends DarkMatterFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends DarkMatterFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
