
package net.mcreator.enderitestuff.item;

import net.minecraft.world.level.Level;
import net.minecraft.world.item.Rarity;
import net.minecraft.world.item.ItemUseAnimation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.InteractionHand;

import net.mcreator.enderitestuff.procedures.FragGrenadeRightclickedProcedure;
import net.mcreator.enderitestuff.procedures.FragGrenadeOnPlayerStoppedUsingProcedure;

public class FragGrenadeItem extends Item {
	public FragGrenadeItem(Item.Properties properties) {
		super(properties.rarity(Rarity.COMMON).stacksTo(16));
	}

	@Override
	public ItemUseAnimation getUseAnimation(ItemStack itemstack) {
		return ItemUseAnimation.SPEAR;
	}

	@Override
	public int getUseDuration(ItemStack itemstack, LivingEntity livingEntity) {
		return 32000;
	}

	@Override
	public InteractionResult use(Level world, Player entity, InteractionHand hand) {
		InteractionResult ar = super.use(world, entity, hand);
		entity.startUsingItem(hand);
		FragGrenadeRightclickedProcedure.execute(world, entity.getX(), entity.getY(), entity.getZ());
		return ar;
	}

	@Override
	public ItemStack finishUsingItem(ItemStack itemstack, Level world, LivingEntity entity) {
		ItemStack retval = super.finishUsingItem(itemstack, world, entity);
		double x = entity.getX();
		double y = entity.getY();
		double z = entity.getZ();
		FragGrenadeOnPlayerStoppedUsingProcedure.execute(entity, itemstack);
		return retval;
	}

	@Override
	public boolean releaseUsing(ItemStack itemstack, Level world, LivingEntity entity, int time) {
		FragGrenadeOnPlayerStoppedUsingProcedure.execute(entity, itemstack);
		return super.releaseUsing(itemstack, world, entity, time);
	}
}
