
package net.mcreator.enderitestuff.network;

import net.neoforged.neoforge.network.handling.IPayloadContext;
import net.neoforged.fml.event.lifecycle.FMLCommonSetupEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.protocol.common.custom.CustomPacketPayload;
import net.minecraft.network.protocol.PacketFlow;
import net.minecraft.network.codec.StreamCodec;
import net.minecraft.network.chat.Component;
import net.minecraft.network.RegistryFriendlyByteBuf;

import net.mcreator.enderitestuff.procedures.JetpackModeSwitchOnKeyPressedProcedure;
import net.mcreator.enderitestuff.EnderiteStuffMod;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD)
public record JetpackModeSwitchMessage(int eventType, int pressedms) implements CustomPacketPayload {
	public static final Type<JetpackModeSwitchMessage> TYPE = new Type<>(ResourceLocation.fromNamespaceAndPath(EnderiteStuffMod.MODID, "key_jetpack_mode_switch"));
	public static final StreamCodec<RegistryFriendlyByteBuf, JetpackModeSwitchMessage> STREAM_CODEC = StreamCodec.of((RegistryFriendlyByteBuf buffer, JetpackModeSwitchMessage message) -> {
		buffer.writeInt(message.eventType);
		buffer.writeInt(message.pressedms);
	}, (RegistryFriendlyByteBuf buffer) -> new JetpackModeSwitchMessage(buffer.readInt(), buffer.readInt()));

	@Override
	public Type<JetpackModeSwitchMessage> type() {
		return TYPE;
	}

	public static void handleData(final JetpackModeSwitchMessage message, final IPayloadContext context) {
		if (context.flow() == PacketFlow.SERVERBOUND) {
			context.enqueueWork(() -> {
				pressAction(context.player(), message.eventType, message.pressedms);
			}).exceptionally(e -> {
				context.connection().disconnect(Component.literal(e.getMessage()));
				return null;
			});
		}
	}

	public static void pressAction(Player entity, int type, int pressedms) {
		Level world = entity.level();
		double x = entity.getX();
		double y = entity.getY();
		double z = entity.getZ();
		// security measure to prevent arbitrary chunk generation
		if (!world.hasChunkAt(entity.blockPosition()))
			return;
		if (type == 0) {

			JetpackModeSwitchOnKeyPressedProcedure.execute(entity);
		}
	}

	@SubscribeEvent
	public static void registerMessage(FMLCommonSetupEvent event) {
		EnderiteStuffMod.addNetworkMessage(JetpackModeSwitchMessage.TYPE, JetpackModeSwitchMessage.STREAM_CODEC, JetpackModeSwitchMessage::handleData);
	}
}
