
package net.mcreator.enderitestuff.network;

import net.neoforged.neoforge.network.handling.IPayloadContext;
import net.neoforged.fml.event.lifecycle.FMLCommonSetupEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.protocol.common.custom.CustomPacketPayload;
import net.minecraft.network.protocol.PacketFlow;
import net.minecraft.network.codec.StreamCodec;
import net.minecraft.network.chat.Component;
import net.minecraft.network.RegistryFriendlyByteBuf;
import net.minecraft.core.BlockPos;

import net.mcreator.enderitestuff.world.inventory.PowerArmorUpgradeGUIMenu;
import net.mcreator.enderitestuff.procedures.SaveItemstack03Procedure;
import net.mcreator.enderitestuff.procedures.SaveItemstack02Procedure;
import net.mcreator.enderitestuff.procedures.SaveItemstack01Procedure;
import net.mcreator.enderitestuff.procedures.SaveItemstack00Procedure;
import net.mcreator.enderitestuff.EnderiteStuffMod;

import java.util.HashMap;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD)
public record PowerArmorUpgradeGUISlotMessage(int slotID, int x, int y, int z, int changeType, int meta) implements CustomPacketPayload {

	public static final Type<PowerArmorUpgradeGUISlotMessage> TYPE = new Type<>(ResourceLocation.fromNamespaceAndPath(EnderiteStuffMod.MODID, "power_armor_upgrade_gui_slots"));
	public static final StreamCodec<RegistryFriendlyByteBuf, PowerArmorUpgradeGUISlotMessage> STREAM_CODEC = StreamCodec.of((RegistryFriendlyByteBuf buffer, PowerArmorUpgradeGUISlotMessage message) -> {
		buffer.writeInt(message.slotID);
		buffer.writeInt(message.x);
		buffer.writeInt(message.y);
		buffer.writeInt(message.z);
		buffer.writeInt(message.changeType);
		buffer.writeInt(message.meta);
	}, (RegistryFriendlyByteBuf buffer) -> new PowerArmorUpgradeGUISlotMessage(buffer.readInt(), buffer.readInt(), buffer.readInt(), buffer.readInt(), buffer.readInt(), buffer.readInt()));
	@Override
	public Type<PowerArmorUpgradeGUISlotMessage> type() {
		return TYPE;
	}

	public static void handleData(final PowerArmorUpgradeGUISlotMessage message, final IPayloadContext context) {
		if (context.flow() == PacketFlow.SERVERBOUND) {
			context.enqueueWork(() -> {
				Player entity = context.player();
				int slotID = message.slotID;
				int changeType = message.changeType;
				int meta = message.meta;
				int x = message.x;
				int y = message.y;
				int z = message.z;
				handleSlotAction(entity, slotID, changeType, meta, x, y, z);
			}).exceptionally(e -> {
				context.connection().disconnect(Component.literal(e.getMessage()));
				return null;
			});
		}
	}

	public static void handleSlotAction(Player entity, int slot, int changeType, int meta, int x, int y, int z) {
		Level world = entity.level();
		HashMap guistate = PowerArmorUpgradeGUIMenu.guistate;
		// security measure to prevent arbitrary chunk generation
		if (!world.hasChunkAt(new BlockPos(x, y, z)))
			return;
		if (slot == 1 && changeType == 0) {

			SaveItemstack01Procedure.execute(world, entity);
		}
		if (slot == 1 && changeType == 1) {

			SaveItemstack01Procedure.execute(world, entity);
		}
		if (slot == 1 && changeType == 2) {
			int amount = meta;

			SaveItemstack01Procedure.execute(world, entity);
		}
		if (slot == 0 && changeType == 0) {

			SaveItemstack00Procedure.execute(world, entity);
		}
		if (slot == 0 && changeType == 1) {

			SaveItemstack00Procedure.execute(world, entity);
		}
		if (slot == 0 && changeType == 2) {
			int amount = meta;

			SaveItemstack00Procedure.execute(world, entity);
		}
		if (slot == 2 && changeType == 0) {

			SaveItemstack02Procedure.execute(world, entity);
		}
		if (slot == 2 && changeType == 1) {

			SaveItemstack02Procedure.execute(world, entity);
		}
		if (slot == 2 && changeType == 2) {
			int amount = meta;

			SaveItemstack02Procedure.execute(world, entity);
		}
		if (slot == 3 && changeType == 0) {

			SaveItemstack03Procedure.execute(world, entity);
		}
		if (slot == 3 && changeType == 1) {

			SaveItemstack03Procedure.execute(world, entity);
		}
		if (slot == 3 && changeType == 2) {
			int amount = meta;

			SaveItemstack03Procedure.execute(world, entity);
		}
	}

	@SubscribeEvent
	public static void registerMessage(FMLCommonSetupEvent event) {
		EnderiteStuffMod.addNetworkMessage(PowerArmorUpgradeGUISlotMessage.TYPE, PowerArmorUpgradeGUISlotMessage.STREAM_CODEC, PowerArmorUpgradeGUISlotMessage::handleData);
	}
}
