
package net.mcreator.enderitestuff.network;

import net.neoforged.neoforge.network.handling.IPayloadContext;
import net.neoforged.fml.event.lifecycle.FMLCommonSetupEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.protocol.common.custom.CustomPacketPayload;
import net.minecraft.network.protocol.PacketFlow;
import net.minecraft.network.codec.StreamCodec;
import net.minecraft.network.chat.Component;
import net.minecraft.network.RegistryFriendlyByteBuf;

import net.mcreator.enderitestuff.EnderiteStuffMod;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD)
public record Shoot1Message(int eventType, int pressedms) implements CustomPacketPayload {
	public static final Type<Shoot1Message> TYPE = new Type<>(ResourceLocation.fromNamespaceAndPath(EnderiteStuffMod.MODID, "key_shoot_1"));
	public static final StreamCodec<RegistryFriendlyByteBuf, Shoot1Message> STREAM_CODEC = StreamCodec.of((RegistryFriendlyByteBuf buffer, Shoot1Message message) -> {
		buffer.writeInt(message.eventType);
		buffer.writeInt(message.pressedms);
	}, (RegistryFriendlyByteBuf buffer) -> new Shoot1Message(buffer.readInt(), buffer.readInt()));

	@Override
	public Type<Shoot1Message> type() {
		return TYPE;
	}

	public static void handleData(final Shoot1Message message, final IPayloadContext context) {
		if (context.flow() == PacketFlow.SERVERBOUND) {
			context.enqueueWork(() -> {
			}).exceptionally(e -> {
				context.connection().disconnect(Component.literal(e.getMessage()));
				return null;
			});
		}
	}

	@SubscribeEvent
	public static void registerMessage(FMLCommonSetupEvent event) {
		EnderiteStuffMod.addNetworkMessage(Shoot1Message.TYPE, Shoot1Message.STREAM_CODEC, Shoot1Message::handleData);
	}
}
